﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;

namespace C1Flex_MaintainRowSelectionAfterSort
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        CellStyle cs;
        int rowIndex = -1;
        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'c1NWindDataSet.Customers' table. You can move, or remove it, as needed.
            this.customersTableAdapter.Fill(this.c1NWindDataSet.Customers);
            c1FlexGrid1.MouseClick += new MouseEventHandler(c1FlexGrid1_MouseClick);
            c1FlexGrid1.AfterSort += new C1.Win.C1FlexGrid.SortColEventHandler(c1FlexGrid1_AfterSort);
            cs = c1FlexGrid1.Styles.Highlight;
            cs.BackColor = Color.LightSeaGreen;
        }

        void c1FlexGrid1_MouseClick(object sender, MouseEventArgs e)
        {
            CurrencyManager cm = (CurrencyManager)BindingContext[this.c1FlexGrid1.DataSource];
            DataRowView dr = cm.Current as DataRowView;
            rowIndex = dr.Row.Table.Rows.IndexOf(dr.Row);
        }

        void c1FlexGrid1_AfterSort(object sender, C1.Win.C1FlexGrid.SortColEventArgs e)
        {
            if (rowIndex > -1)
            {
                foreach (C1.Win.C1FlexGrid.Row rw in c1FlexGrid1.Rows)
                {
                    CurrencyManager cm = (CurrencyManager)BindingContext[this.c1FlexGrid1.DataSource];
                    DataRowView dr = rw.DataSource as DataRowView;
                    if (dr != null)
                    {
                        int currIndex = dr.Row.Table.Rows.IndexOf(dr.Row);

                        if (currIndex == rowIndex)
                        {
                            CellRange cr = c1FlexGrid1.GetCellRange(rw.Index, 1);
                            // to scroll the selected row in the visible area
                            c1FlexGrid1.Select(cr, true);
                            cr = c1FlexGrid1.GetCellRange(rw.Index, 0, rw.Index, c1FlexGrid1.Cols.Count - 1);
                            c1FlexGrid1.Select(cr, false);
                            break;
                        }
                    }
                }
            }
        }


    }
}
